Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::AugRestoSystemSolver Class Reference

Class that converts the an augmented system with compound restoration pieces into a smaller "pivoted" system to be solved with an existing AugSystemSolver. More...

`#include <IpAugRestoSystemSolver.hpp>`

Inheritance diagram for Ipopt::AugRestoSystemSolver:
[legend]

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject More...
virtual ESymSolverStatus | Solve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, const Vector &rhs_x, const Vector &rhs_s, const Vector &rhs_c, const Vector &rhs_d, Vector &sol_x, Vector &sol_s, Vector &sol_c, Vector &sol_d, bool check_NegEVals, Index numberOfNegEVals)
| Translate the augmented system (in the full space of the restoration variables) into the smaller space of the original variables. More...
virtual Index | NumberOfNegEVals () const
| Returns the number of negative eigenvalues from the original augmented system call. More...
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver. More...
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve. More...
Constructors/Destructors
| AugRestoSystemSolver (AugSystemSolver &orig_aug_solver, bool skip_orig_aug_solver_init=true)
| Constructor. More...
virtual | ~AugRestoSystemSolver ()
| Default destructor. More...
Public Member Functions inherited from Ipopt::AugSystemSolver
virtual ESymSolverStatus | MultiSolve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, std::vector< SmartPtr< const Vector > > &rhs_xV, std::vector< SmartPtr< const Vector > > &rhs_sV, std::vector< SmartPtr< const Vector > > &rhs_cV, std::vector< SmartPtr< const Vector > > &rhs_dV, std::vector< SmartPtr< Vector > > &sol_xV, std::vector< SmartPtr< Vector > > &sol_sV, std::vector< SmartPtr< Vector > > &sol_cV, std::vector< SmartPtr< Vector > > &sol_dV, bool check_NegEVals, Index numberOfNegEVals)
| Like Solve, but for multiple right hand sides. More...
| AugSystemSolver ()
| Default constructor. More...
virtual | ~AugSystemSolver ()
| Default destructor. More...
Public Member Functions inherited from Ipopt::AlgorithmStrategyObject
bool | Initialize (const Journalist &jnlst, IpoptNLP &ip_nlp, IpoptData &ip_data, IpoptCalculatedQuantities &ip_cq, const OptionsList &options, const std::string &prefix)
| This method is called every time the algorithm starts again - it is used to reset any internal state. More...
bool | ReducedInitialize (const Journalist &jnlst, const OptionsList &options, const std::string &prefix)
| Reduced version of the Initialize method, which does not require special Ipopt information. More...
| AlgorithmStrategyObject ()
| Default Constructor. More...
virtual | ~AlgorithmStrategyObject ()
| Default Destructor. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| AugRestoSystemSolver ()
| Default Constructor. More...
| AugRestoSystemSolver (const AugRestoSystemSolver &)
| Copy Constructor. More...
void | operator= (const AugRestoSystemSolver &)
| Overloaded Equals Operator. More...
Methods to calculate the cached quantities
SmartPtr< const Vector > | Neg_Omega_c_plus_D_c (const SmartPtr< const Vector > &sigma_tilde_n_c_inv, const SmartPtr< const Vector > &sigma_tilde_p_c_inv, const Vector *D_c, const Vector &any_vec_in_c)
SmartPtr< const Vector > | Neg_Omega_d_plus_D_d (const Matrix &Pd_L, const SmartPtr< const Vector > &sigma_tilde_n_d_inv, const Matrix &neg_Pd_U, const SmartPtr< const Vector > &sigma_tilde_p_d_inv, const Vector *D_d, const Vector &any_vec_in_d)
SmartPtr< const Vector > | Sigma_tilde_n_c_inv (const SmartPtr< const Vector > &sigma_tilde_n_c, Number delta_x, const Vector &any_vec_in_n_c)
| Sigma tilde is the sum of Sigma and delta_x times the identity. More...
SmartPtr< const Vector > | Sigma_tilde_p_c_inv (const SmartPtr< const Vector > &sigma_tilde_p_c, Number delta_x, const Vector &any_vec_in_p_c)
SmartPtr< const Vector > | Sigma_tilde_n_d_inv (const SmartPtr< const Vector > &sigma_tilde_n_d, Number delta_x, const Vector &any_vec_in_n_d)
SmartPtr< const Vector > | Sigma_tilde_p_d_inv (const SmartPtr< const Vector > &sigma_tilde_p_d, Number delta_x, const Vector &any_vec_in_p_d)
SmartPtr< const Vector > | D_x_plus_wr_d (const SmartPtr< const Vector > &CD_x0, Number factor, const Vector &wr_d)
SmartPtr< const Vector > | Rhs_cR (const Vector &rhs_c, const SmartPtr< const Vector > &sigma_tilde_n_c_inv, const Vector &rhs_n_c, const SmartPtr< const Vector > &sigma_tilde_p_c_inv, const Vector &rhs_p_c)
SmartPtr< const Vector > | Rhs_dR (const Vector &rhs_d, const SmartPtr< const Vector > &sigma_tilde_n_d_inv, const Vector &rhs_n_d, const Matrix &pd_L, const SmartPtr< const Vector > &sigma_tilde_p_d_inv, const Vector &rhs_p_d, const Matrix &pd_U)

## Private Attributes
SmartPtr< AugSystemSolver > | orig_aug_solver_
bool | skip_orig_aug_solver_init_
Caches for some of the necessary calculated quantities
CachedResults< SmartPtr< Vector > > | neg_omega_c_plus_D_c_cache_
CachedResults< SmartPtr< Vector > > | neg_omega_d_plus_D_d_cache_
CachedResults< SmartPtr< Vector > > | sigma_tilde_n_c_inv_cache_
CachedResults< SmartPtr< Vector > > | sigma_tilde_p_c_inv_cache_
CachedResults< SmartPtr< Vector > > | sigma_tilde_n_d_inv_cache_
CachedResults< SmartPtr< Vector > > | sigma_tilde_p_d_inv_cache_
CachedResults< SmartPtr< Vector > > | d_x_plus_wr_d_cache_
CachedResults< SmartPtr< Vector > > | rhs_cR_cache_
CachedResults< SmartPtr< Vector > > | rhs_dR_cache_

## Additional Inherited Members
Protected Member Functions inherited from Ipopt::AlgorithmStrategyObject
const Journalist & | Jnlst () const
IpoptNLP & | IpNLP () const
IpoptData & | IpData () const
IpoptCalculatedQuantities & | IpCq () const
bool | HaveIpData () const

## Detailed Description

Class that converts the an augmented system with compound restoration pieces into a smaller "pivoted" system to be solved with an existing AugSystemSolver.

This is really a decorator that changes the behavior of the AugSystemSolver to account for the known structure of the restoration phase.

Definition at line 23 of file IpAugRestoSystemSolver.hpp.

## Constructor & Destructor Documentation

Ipopt::AugRestoSystemSolver::AugRestoSystemSolver | ( | AugSystemSolver & | orig_aug_solver,
|  | bool | skip_orig_aug_solver_init = `true`
| ) |  |

Constructor.

Here, orig_aug_solver is the object for solving the original augmented system. The flag skip_orig_aug_solver_init indicates, if the initialization call (to Initialize) should be skipped; this flag will usually be true, so that the symbolic factorization of the main algorithm will be used.

virtual Ipopt::AugRestoSystemSolver::~AugRestoSystemSolver | ( |  | ) |
| virtual

Default destructor.

Ipopt::AugRestoSystemSolver::AugRestoSystemSolver | ( |  | ) |
| private

Default Constructor.

Ipopt::AugRestoSystemSolver::AugRestoSystemSolver | ( | const AugRestoSystemSolver & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

bool Ipopt::AugRestoSystemSolver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix
| ) |  |
| virtual

overloaded from AlgorithmStrategyObject

Implements Ipopt::AugSystemSolver.

virtual ESymSolverStatus Ipopt::AugRestoSystemSolver::Solve | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix * | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix * | J_d,
|  | const Vector * | D_d,
|  | double | delta_d,
|  | const Vector & | rhs_x,
|  | const Vector & | rhs_s,
|  | const Vector & | rhs_c,
|  | const Vector & | rhs_d,
|  | Vector & | sol_x,
|  | Vector & | sol_s,
|  | Vector & | sol_c,
|  | Vector & | sol_d,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals
| ) |  |
| virtual

Translate the augmented system (in the full space of the restoration variables) into the smaller space of the original variables.

Reimplemented from Ipopt::AugSystemSolver.

virtual Index Ipopt::AugRestoSystemSolver::NumberOfNegEVals | ( |  | ) | const
| inline virtual

Returns the number of negative eigenvalues from the original augmented system call.

Implements Ipopt::AugSystemSolver.

Definition at line 76 of file IpAugRestoSystemSolver.hpp.

virtual bool Ipopt::AugRestoSystemSolver::ProvidesInertia | ( |  | ) | const
| inline virtual

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::AugSystemSolver.

Definition at line 84 of file IpAugRestoSystemSolver.hpp.

virtual bool Ipopt::AugRestoSystemSolver::IncreaseQuality | ( |  | ) |
| inline virtual

Request to increase quality of solution for next solve.

Ask underlying linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implements Ipopt::AugSystemSolver.

Definition at line 95 of file IpAugRestoSystemSolver.hpp.

void Ipopt::AugRestoSystemSolver::operator= | ( | const AugRestoSystemSolver & |  | ) |
| private

Overloaded Equals Operator.

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Neg_Omega_c_plus_D_c | ( | const SmartPtr< const Vector > & | sigma_tilde_n_c_inv,
|  | const SmartPtr< const Vector > & | sigma_tilde_p_c_inv,
|  | const Vector * | D_c,
|  | const Vector & | any_vec_in_c
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Neg_Omega_d_plus_D_d | ( | const Matrix & | Pd_L,
|  | const SmartPtr< const Vector > & | sigma_tilde_n_d_inv,
|  | const Matrix & | neg_Pd_U,
|  | const SmartPtr< const Vector > & | sigma_tilde_p_d_inv,
|  | const Vector * | D_d,
|  | const Vector & | any_vec_in_d
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Sigma_tilde_n_c_inv | ( | const SmartPtr< const Vector > & | sigma_tilde_n_c,
|  | Number | delta_x,
|  | const Vector & | any_vec_in_n_c
| ) |  |
| private

Sigma tilde is the sum of Sigma and delta_x times the identity.

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Sigma_tilde_p_c_inv | ( | const SmartPtr< const Vector > & | sigma_tilde_p_c,
|  | Number | delta_x,
|  | const Vector & | any_vec_in_p_c
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Sigma_tilde_n_d_inv | ( | const SmartPtr< const Vector > & | sigma_tilde_n_d,
|  | Number | delta_x,
|  | const Vector & | any_vec_in_n_d
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Sigma_tilde_p_d_inv | ( | const SmartPtr< const Vector > & | sigma_tilde_p_d,
|  | Number | delta_x,
|  | const Vector & | any_vec_in_p_d
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::D_x_plus_wr_d | ( | const SmartPtr< const Vector > & | CD_x0,
|  | Number | factor,
|  | const Vector & | wr_d
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Rhs_cR | ( | const Vector & | rhs_c,
|  | const SmartPtr< const Vector > & | sigma_tilde_n_c_inv,
|  | const Vector & | rhs_n_c,
|  | const SmartPtr< const Vector > & | sigma_tilde_p_c_inv,
|  | const Vector & | rhs_p_c
| ) |  |
| private

SmartPtr<const Vector> Ipopt::AugRestoSystemSolver::Rhs_dR | ( | const Vector & | rhs_d,
|  | const SmartPtr< const Vector > & | sigma_tilde_n_d_inv,
|  | const Vector & | rhs_n_d,
|  | const Matrix & | pd_L,
|  | const SmartPtr< const Vector > & | sigma_tilde_p_d_inv,
|  | const Vector & | rhs_p_d,
|  | const Matrix & | pd_U
| ) |  |
| private

## Member Data Documentation

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::neg_omega_c_plus_D_c_cache_
| private

Definition at line 121 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::neg_omega_d_plus_D_d_cache_
| private

Definition at line 122 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::sigma_tilde_n_c_inv_cache_
| private

Definition at line 123 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::sigma_tilde_p_c_inv_cache_
| private

Definition at line 124 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::sigma_tilde_n_d_inv_cache_
| private

Definition at line 125 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::sigma_tilde_p_d_inv_cache_
| private

Definition at line 126 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::d_x_plus_wr_d_cache_
| private

Definition at line 127 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::rhs_cR_cache_
| private

Definition at line 128 of file IpAugRestoSystemSolver.hpp.

CachedResults< SmartPtr<Vector> > Ipopt::AugRestoSystemSolver::rhs_dR_cache_
| private

Definition at line 129 of file IpAugRestoSystemSolver.hpp.

SmartPtr<AugSystemSolver> Ipopt::AugRestoSystemSolver::orig_aug_solver_
| private

Definition at line 191 of file IpAugRestoSystemSolver.hpp.

bool Ipopt::AugRestoSystemSolver::skip_orig_aug_solver_init_
| private

Definition at line 192 of file IpAugRestoSystemSolver.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/IpAugRestoSystemSolver.hpp